package com.ness.mediametadataretriever;

import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;

import java.util.HashMap;
import java.lang.Runnable;
import java.util.concurrent.CompletableFuture;

import android.os.Build;
import android.os.Handler;
import android.os.Looper;
import androidx.annotation.RequiresApi;


/** MediametadataretrieverPlugin */
public class MediametadataretrieverPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "nessmediametadataretriever");
    channel.setMethodCallHandler(this);
  }
  @RequiresApi(api = Build.VERSION_CODES.N)
  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("NessMetadataRetriever")) {
      CompletableFuture.runAsync(new Runnable() {
        @Override
        public void run() {
          String filePath = (String) call.argument("filePath");
          MetadataRetriever retriever = new MetadataRetriever();
          retriever.setFilePath(filePath);
          final HashMap<String, Object> response = new HashMap<String, Object>();
          response.put("metadata", retriever.getMetadata());
          response.put("path", filePath);
          response.put("albumArt", retriever.getAlbumArt());
          retriever.release();
          new Handler(Looper.getMainLooper())
                  .post(new Runnable() {
                    @Override
                    public void run() {
                      result.success(response);
                    }
                  });
        }
      });
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
