package com.ness.mediametadataretriever;

import android.media.MediaMetadataRetriever;
import java.util.HashMap;
import java.lang.System;

public class MetadataRetriever extends MediaMetadataRetriever {
    public MetadataRetriever() {
        super();
    }

    public void setFilePath(String filePath) {
        this.setDataSource(filePath);
    }

    public HashMap<String, Object> getMetadata() {
        HashMap<String, Object> metadata = new HashMap<String, Object>();
        metadata.put("trackName", this.extractMetadata(this.METADATA_KEY_TITLE));
        metadata.put("trackArtistNames", this.extractMetadata(this.METADATA_KEY_ARTIST));
        metadata.put("albumName", this.extractMetadata(this.METADATA_KEY_ALBUM));
        metadata.put("albumArtistName", this.extractMetadata(this.METADATA_KEY_ALBUMARTIST));
        metadata.put("path", this.extractMetadata(this.METADATA_KEY_ALBUMARTIST));
        return metadata;
    }

    public byte[] getAlbumArt() {
        return this.getEmbeddedPicture();
    }
}